#!/usr/bin/python
# coding=utf8

from __future__ import division

# Graphik und Berechnungen

import matplotlib

### Wir müssen uns hier für ein Graphik-System ('backend') entscheiden,
### wenn wir dieses die Ereigniskontroll übernehmen lassen wollen: 'gtk'

matplotlib.use('GTKAgg')
import gobject

import matplotlib.pyplot as plt

import numpy as np



class Anzeige(object):
	'''Anzeige-Objekt, zeigt 'chunk' frames
	an, x-Achse beschriftet mit den korrekten Zeiten.
	Das zweite Argument ist die Sample-Rate'''
	def __init__(self,chunk,rate):
		self.chunk=chunk
		self.rate=rate
		self.fig,self.ax=plt.subplots(1,1)  
		self.ax = plt.axes(ylim=(-1,1),xlim=(0,chunk/self.rate))
		self.xwerte=np.arange(chunk)/self.rate
		
		self.kurve, = self.ax.plot(self.xwerte,np.zeros(self.chunk), lw=2)
		self.fig.canvas.draw()
		plt.pause(0.001)
		gobject.idle_add(self.zeichnen)

	def update(self,data):
		'''Plottet 'data' '''
		self.kurve.set_data(self.xwerte,data/2**16)
			
	def zeichnen(self,*args):
		self.fig.canvas.draw()
		return True


if __name__=='__main__':
	import time
	
	anz=Anzeige(2**11,44100)

	for i in range(1000):
		anz.update(np.random.randn(2**11)*2**14)
		anz.zeichnen()
		time.sleep(0.1)
